// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2021-05-18T14:36:08, by ESR Version 2.4.42.0 using ESR Database SWS_EA_ESR_Cloud_Prod
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using System.Linq;
using System.Collections.Generic;
using DataContracts;
using System.Text.RegularExpressions;

namespace Ato.EN.IntegrationServices.CodeGenerationLDGNNRequest2021
{

    public partial class LDGNN2021Validator
    {
        /// <summary>
        /// The max parameter name length is restricted by the SBR1 and SBR2 schemas - the lowest common denominator of SBR 1 is used as the default
        /// </summary>
        private int _maxParameterNameLength;

        /// <summary>
        /// The max parameter value length is restricted by the SBR1 and SBR2 schemas
        /// </summary>
        private int _maxParameterValueLength;

        /// <summary>
        /// The SBR1 and ebms3 schemas do not allow parameter names or values to be the empty string
        /// </summary>
        private string _emptyParameterValue;

        /// <summary>
        /// Initializes a new instance of the <see cref="LDGNN2021Validator" /> class.
        /// </summary>
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public LDGNN2021Validator(int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY")
        {
            _maxParameterNameLength = maxParameterNameLength;
            _maxParameterValueLength = maxParameterValueLength;
            _emptyParameterValue = emptyParameterValue;
        }

        #region Functions
        private static IEnumerable<string> Union(IEnumerable<string> list1, IEnumerable<string> list2)
        {
            IEnumerable<string> response;

            if (list1 == null && list2 == null)
            {
                response = null;
            }
            else if (list1 == null)
            {
                response = list2.Distinct();
            }
            else if (list2 == null)
            {
                response = list1.Distinct();
            }
            else
            {
                response = list1.Union(list2);
            }

            return response;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        // This is just context and tuple counts where they are integer values - easier that changing the parsing logic to just return the value
        private static int Count(int count)
        {
            return count;
        }


        private static int Count<T>(IEnumerable<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static int Count<T>(ICollection<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static bool exists(bool value)
        {
            return value;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString().ToLower() : string.Empty;
        }

        private static string GetValueOrEmptyDate(DateTime? val)
        {
            return (val.HasValue) ? val.Value.ToString("yyyy-MM-dd") : string.Empty;
        }

        private static string GetValueOrEmptyDate(string val)
        {
            DateTime dateTimeOut;
            if (DateTime.TryParse(val, out dateTimeOut))
            {
                return dateTimeOut.ToString("yyyy-MM-dd");
            }
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmptyDateTime(string val)
        {
            DateTime dateTimeOut;
            if (DateTime.TryParse(val, out dateTimeOut))
            {
                return dateTimeOut.ToString("yyyy-MM-ddTHH:mm:ssZ");
            }
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmptyDateTime(DateTime? val)
        {
            return (val.HasValue) ? val.Value.ToString("yyyy-MM-ddTHH:mm:ssZ") : string.Empty;
        }

        private static string GetValueOrEmpty(string val)
        {
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmpty(decimal? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(int? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

         /// <summary>
         /// Get string value between [first] a and [last] b.
         /// </summary>
        public static string Between(string value, string a, string b)
        {
            int posA = value.IndexOf(a);
            int posB = value.LastIndexOf(b);
            if (posA == -1)
            {
                return "";
            }
            if (posB == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= posB)
            {
                return "";
            }
            return value.Substring(adjustedPosA, posB - adjustedPosA);
        }

         /// <summary>
         /// Get string value after [first] a.
         /// </summary>
        public static string Before(string value, string a)
        {
            int posA = value.IndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            return value.Substring(0, posA);
        }

         /// <summary>
         /// Get string value after [last] a.
         /// </summary>
        public static string After(string value, string a)
        {
            int posA = value.LastIndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= value.Length)
            {
                return "";
            }
            return value.Substring(adjustedPosA);
        }

        private static int Length(object field)
        {
            if (field == null)
            return 0;
            else
            return field.ToString().Trim().Length;
        }

        private static bool NotSameValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return (from x in nodes select x).Distinct().Count() != 1;
        }

        private static bool HasDuplicateValues(IEnumerable<DateTime> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(IEnumerable<DateTime?> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool NotSameValues(IEnumerable<DateTime> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(IEnumerable<DateTime?> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool HasDuplicateValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(params object[] nodes)
        {
           if (nodes == null)
                return false;

            nodes = nodes.Where(x => x != null).ToArray();
            return !((from x in nodes select x).Distinct().Count() == nodes.Count());
        
        }

        private int DuplicateValueIndex(IEnumerable<object> values)
        {
            int response = 0;
            var hashset = new HashSet<object>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private int DuplicateValueIndex<T>(IEnumerable<T?> values) where T : struct
        {
            int response = 0;
            var hashset = new HashSet<T?>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private static bool IsDate(object value)
        {
            DateTime dateValue;
            return (value != null && DateTime.TryParse(value.ToString(), out dateValue));
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }

        public DateTime Date(DateTime? datetime)
        {                   
            return datetime.GetValueOrDefault().Date;
        }

				//The logic in After function expects "---" for day and "--" for month. 
				//Since hyphen was missing the date always returned null
        public DateTime? ConvertToDate(int day, int month, int year)
        {
					return ConvertToDate(day == 0 ? null : "---" + day.ToString(), month == 0 ? null : "--" + month.ToString(), year == 0 ? null : year.ToString());
        }

        public DateTime? ConvertToDate(string day, string month, string year)
        {
            DateTime? response;
            DateTime result;

            if (year == null || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        public DateTime? ConvertToDate(string day, string month, int year)
        {
            DateTime? response;
            DateTime result;

            if (year == 0 || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year.ToString() + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        private static int Day(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Day;
            }

            return response;
        }


        private static int Day(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Day;

        }


        private static string Month(string dateAsString)
        {
            string response = null;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.ToString("MMMM");
            }
            else
            {
                return "NotAMonth";
            }

            return response;
        }

        private static string Month(DateTime? date)
        {
            if (date == null)
                return "NotAMonth";
            else
                return date.Value.ToString("MMMM");
        }


        private static int MonthAsInt(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Month;
            }

            return response;
        }

        private static int MonthAsInt(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            return date.Value.Month;
        }


        private static int Year(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Year;
            }

            return response;
        }

        private static int Year(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Year;
        }


        private static int CurrentFinancialYear()
        {
            return DateToFinancialYear(DateTime.Now, 7);
        }

        private static int FinancialYear(string dateAsString)
        {
            return DateToFinancialYear(dateAsString, 7);
        }

        private static int FinancialYear(DateTime? date)
        {
            return DateToFinancialYear(date, 7);
        }

        private static int DateToFinancialYear(string dateAsString, int startingMonth)
        {
            int response = 0;
            DateTime date;
            if (DateTime.TryParse(dateAsString, out date))
            {
                response = DateToFinancialYear(date, startingMonth);
            }

            return response;
        }
        private static int DateToFinancialYear(DateTime? date, int startingMonth)
        {
            int response;
            if (date == null)
            {
                response = 0;
            }
            else
            {
                int year = date.Value.Year;
                int month = date.Value.Month;

                if (startingMonth > month)
                    response = year;
                else
                    response = year + 1;
            }
            return response;
        }


        private static int FBTYear(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
                response = FBTYear(date);
            return response;
        }

        private static int FBTYear(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            else
            {
                if (date.Value.Month > 3)
                    return date.Value.Year + 1;
                else
                    return date.Value.Year;
            }
        }

        private static DateTime? AddMonthsToDate(DateTime? dateTime, int months)
        {
            return dateTime == null ? null : (DateTime?)dateTime.Value.AddMonths(months);
        }

        private static bool IsNumeric(object value)
        {
            decimal numbervalue;
            return (value != null && decimal.TryParse(value.ToString(), out numbervalue));
        }

        private static bool NotMonetary(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(int? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }

        private static bool NotNumeric(long? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }


        private static bool OutsideRange(decimal field, decimal expression, int range)
        {
            bool response;

            response = (field < (expression - range)) || (field > (expression + range));

            return response;
        }


        private static bool FailsUSIAlgorithm(string usi, string abn)
        {
            bool response = true;
            if (usi == null || abn == null)
            {
                response = false;
            }
            else
            {
                usi = usi.Trim();
                abn = abn.Trim();
                if (usi.Length == 14)
                {
                    int numeric;
                    if (usi.Substring(0, 11) == abn && int.TryParse(usi.Substring(11, 3), out numeric))
                        response = false;

                }
                else if (usi.Length == 9)
                {

                    if (Regex.IsMatch(usi, @"^([a-zA-Z]{3}\d{4}[a-zA-Z]{2})$"))
                        response = false;
                }
            }
            return response;
        }

        private static bool FailsTANAlgorithm(string tan)
        {
            bool response;
            decimal decimalTan;

            if (tan == null)
                return false;

            tan = tan.Trim();

            if (!decimal.TryParse(tan, out decimalTan))
                return true;

            if (tan.Length != 8)
                return true;

            decimal tanSum =
                7 * int.Parse(tan.Substring(0, 1)) +
                9 * int.Parse(tan.Substring(1, 1)) +
                8 * int.Parse(tan.Substring(2, 1)) +
                4 * int.Parse(tan.Substring(3, 1)) +
                6 * int.Parse(tan.Substring(4, 1)) +
                3 * int.Parse(tan.Substring(5, 1)) +
                5 * int.Parse(tan.Substring(6, 1)) +
                1 * int.Parse(tan.Substring(7, 1));

            if ((tanSum % 11) == 0)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsABNAlgorithm(string abn)
        {
            bool response;
            decimal decimalAbn;

            if (abn == null)
                return false;

            abn = abn.Trim();

            if (!decimal.TryParse(abn, out decimalAbn))
                return true;

            if (abn.Length != 11)
                return true;

            decimal abnSum =
                10 * (int.Parse(abn.Substring(0, 1)) - 1) +
                1 * int.Parse(abn.Substring(1, 1)) +
                3 * int.Parse(abn.Substring(2, 1)) +
                5 * int.Parse(abn.Substring(3, 1)) +
                7 * int.Parse(abn.Substring(4, 1)) +
                9 * int.Parse(abn.Substring(5, 1)) +
                11 * int.Parse(abn.Substring(6, 1)) +
                13 * int.Parse(abn.Substring(7, 1)) +
                15 * int.Parse(abn.Substring(8, 1)) +
                17 * int.Parse(abn.Substring(9, 1)) +
                19 * int.Parse(abn.Substring(10, 1));

            if ((abnSum % 89) == 0)
                response = false;
            else
                response = true;

            return response;
        }
        private static bool FailsACNAlgorithm(string acn)
        {
            bool response;
            decimal decimalAbn;
            if (acn == null)
                return false;

            acn = acn.Trim();

            if (!decimal.TryParse(acn, out decimalAbn))
                return true;

            if (acn.Length != 9)
                return true;

            decimal abnSum =
                8 * int.Parse(acn.Substring(0, 1)) +
                7 * int.Parse(acn.Substring(1, 1)) +
                6 * int.Parse(acn.Substring(2, 1)) +
                5 * int.Parse(acn.Substring(3, 1)) +
                4 * int.Parse(acn.Substring(4, 1)) +
                3 * int.Parse(acn.Substring(5, 1)) +
                2 * int.Parse(acn.Substring(6, 1)) +
                1 * int.Parse(acn.Substring(7, 1));

            decimal checkDigit = int.Parse(acn.Substring(8, 1));
            decimal acnRemainder = abnSum % 10;

            if (((10 - acnRemainder) % 10) == checkDigit)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsTFNAlgorithm(string tfn)
        {
            bool response;
            decimal decimalTfn;

            if (tfn == null)
                return false;

            tfn = tfn.Trim();
            tfn = Regex.Replace(tfn, "^0+", "");

            if (!decimal.TryParse(tfn, out decimalTfn))
                return true;

            if (tfn.Length < 8)
                return true;


            decimal tfn1To7Sum =
                1 * int.Parse(tfn.Substring(0, 1)) +
                4 * int.Parse(tfn.Substring(1, 1)) +
                3 * int.Parse(tfn.Substring(2, 1)) +
                7 * int.Parse(tfn.Substring(3, 1)) +
                5 * int.Parse(tfn.Substring(4, 1)) +
                8 * int.Parse(tfn.Substring(5, 1)) +
                6 * int.Parse(tfn.Substring(6, 1));

            decimal tfn8 = 9 * int.Parse(tfn.Substring(7, 1));

            if (tfn.Length == 8)
            {
                decimal tFNLg8WSum9 = 10 * int.Parse(tfn.Substring(7, 1));
                decimal tFNLg8WSum = tfn1To7Sum + tFNLg8WSum9;

                if ((tFNLg8WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else if (tfn.Length == 9)
            {
                decimal tfn9 = 10 * int.Parse(tfn.Substring(8, 1));
                decimal tFNLg9WSum = tfn1To7Sum + tfn8 + tfn9;

                if ((tFNLg9WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else
            {
                response = true;
            }

            return response;
        }


        private static decimal ConditionalValue(bool expression, decimal? trueVal, decimal? falseVal)
        {
             return expression ? trueVal.GetValueOrDefault() : falseVal.GetValueOrDefault();
        }

        private static decimal AsNumeric(string value)
        {
             decimal numberValue;
             decimal.TryParse(value, out numberValue);
             return numberValue;
        }

        private static bool RegexMatch(int? field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static bool RegexMatch(string field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static RegexOptions GetRegexOption(string flags)
        {
            RegexOptions options = RegexOptions.None;

            char[] characters = flags.ToCharArray();

            foreach (char character in characters)
            {
                switch (character)
                {
                    case 'i':                        
                        options = options | RegexOptions.IgnoreCase;                       
                        break;
                    case 'm':                        
                        options = options | RegexOptions.Multiline;                       
                        break;
                    case 's':                        
                            options = options | RegexOptions.Singleline;                       
                        break;
                    case 'n':                        
                            options = options | RegexOptions.ExplicitCapture;                       
                        break;
                    case 'x':                       
                            options = options | RegexOptions.IgnorePatternWhitespace;                       
                        break;
                }
            }

            return options;
        }

        private static string Substring(object field, int start, int length)
        {
            return field.ToString().Substring(start, length);
        }
        
        /// <summary>
        /// Returns an occurrence index as [occurrenceIndex] of occurrenceIndex > 0, otherwise the empty string
        /// </summary>
        /// <param name="occurrenceIndex">Index of the occurrence.</param>
        /// <returns>Occurrence in XPath [#] format</returns>
        public string OccurrenceIndex(int occurrenceIndex)
        {
            return occurrenceIndex > 0 ? "[" + occurrenceIndex + "]" : "";
        }

        #endregion // Functions

        public LDGNN2021 ConsumedReport { get; private set; }

        private static Dictionary<string, ProcessMessageDocument> _processMessageDocuments = new Dictionary<string,ProcessMessageDocument>();

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public List<ProcessMessageDocument> ValidateReport(LDGNN2021 report)
        {

            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;

            this.ConsumedReport = report;

            // ------------------------------------------------------------------------------
            // Validations are now done in code.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C#.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------

    
            #region VR.ATO.LDGNN.000001
    
            /*  VR.ATO.LDGNN.000001
            The Australian Business Number (ABN) of the Registered agent must pass the ABN algorithm check.
    
            Legacy Rule Format:
            (^LDGNN01 <> NULL) AND (FailsABNAlgorithm(^LDGNN01))

            Technical Business Rule Format:
            (^LDGNN01 <> NULL) AND (FailsABNAlgorithm(^LDGNN01))
    
            Data Elements:
    
            ^LDGNN01 = LDGNN:INT:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.LDGNN01 != null && FailsABNAlgorithm(report.LDGNN01));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000001", Severity = ProcessMessageSeverity.Error,
                    Description = @"Registered agent ABN is invalid.",
                    LongDescription = @"The Australian Business Number (ABN) of the Registered agent has failed the algorithm check.",
                    Location = "/tns:LDGNN/tns:INT/tns:AustralianBusinessNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000001"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN01", Value = report.LDGNN01 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000001
    
            #region VR.ATO.LDGNN.000002
    
            /*  VR.ATO.LDGNN.000002
            The Registered Agent Number (RAN) must pass the Tax Agent Number (TAN) algorithm check.
    
            Legacy Rule Format:
            (^LDGNN02 <> NULL) AND (((Length(^LDGNN02) =7) AND (FailsTANAlgorithm(Concat('0', ^LDGNN02)))) OR ((Length(^LDGNN02) =8) AND (FailsTANAlgorithm(^LDGNN02))))

            Technical Business Rule Format:
            (^LDGNN02 <> NULL) AND (((Length(^LDGNN02) =7) AND (FailsTANAlgorithm(Concat('0', ^LDGNN02)))) OR ((Length(^LDGNN02) =8) AND (FailsTANAlgorithm(^LDGNN02))))
    
            Data Elements:
    
            ^LDGNN02 = LDGNN:INT:Identifiers.TaxAgentNumber.Identifier
            */
            assertion = (report.LDGNN02 != null && (Length(report.LDGNN02) == 7 && FailsTANAlgorithm(string.Concat(@"0", report.LDGNN02)) || Length(report.LDGNN02) == 8 && FailsTANAlgorithm(report.LDGNN02)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000002", Severity = ProcessMessageSeverity.Error,
                    Description = @"Registered agent RAN is invalid.",
                    LongDescription = @"The Registered Agent Number (RAN) has failed the algorithm check.",
                    Location = "/tns:LDGNN/tns:INT/tns:TaxAgentNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000002"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN02", Value = GetValueOrEmpty(report.LDGNN02) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000002
    
            #region VR.ATO.LDGNN.000003
    
            /*  VR.ATO.LDGNN.000003
            The Tax File Number (TFN) of the Client must pass the TFN algorithm check.
    
            Legacy Rule Format:
            (^LDGNN03 <> NULL) AND (FailsTFNAlgorithm(^LDGNN03))

            Technical Business Rule Format:
            (^LDGNN03 <> NULL) AND (FailsTFNAlgorithm(^LDGNN03))
    
            Data Elements:
    
            ^LDGNN03 = LDGNN:RP:Identifiers.TaxFileNumber.Identifier
            */
            assertion = (report.LDGNN03 != null && FailsTFNAlgorithm(report.LDGNN03));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000003", Severity = ProcessMessageSeverity.Error,
                    Description = @"Client TFN is invalid.",
                    LongDescription = @"The Tax File Number (TFN) of the Client has failed the algorithm check.",
                    Location = "/tns:LDGNN/tns:RP/tns:TaxFileNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000003"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN03", Value = GetValueOrEmpty(report.LDGNN03) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000003
    
            #region VR.ATO.LDGNN.000004
    
            /*  VR.ATO.LDGNN.000004
            The Australian Business Number (ABN) of the Client must pass the ABN algorithm check.
    
            Legacy Rule Format:
            (^LDGNN04 <> NULL) AND (FailsABNAlgorithm(^LDGNN04))

            Technical Business Rule Format:
            (^LDGNN04 <> NULL) AND (FailsABNAlgorithm(^LDGNN04))
    
            Data Elements:
    
            ^LDGNN04 = LDGNN:RP:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.LDGNN04 != null && FailsABNAlgorithm(report.LDGNN04));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000004", Severity = ProcessMessageSeverity.Error,
                    Description = @"Client ABN is invalid.",
                    LongDescription = @"The Australian Business Number (ABN) of the Client has failed the algorithm check.",
                    Location = "/tns:LDGNN/tns:RP/tns:AustralianBusinessNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000004"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN04", Value = GetValueOrEmpty(report.LDGNN04) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000004
    
            #region VR.ATO.LDGNN.000006
    
            /*  VR.ATO.LDGNN.000006
            If provided, Intermediary Signature Indicator must be 'TRUE'
    
            Legacy Rule Format:
            (^LDGNN303 <> NULL) AND (^LDGNN09 <> TRUE)

            Technical Business Rule Format:
            (^LDGNN303 <> NULL) AND (^LDGNN09 <> TRUE)
    
            Data Elements:
    
            ^LDGNN09 = LDGNN:INT:INTDeclaration:Declaration.StatementAccepted.Indicator
    
            ^LDGNN303 = LDGNN:INT:INTDeclaration
            */
            assertion = (report.InT_INTDeclarationCollectionExists != false && report.LDGNN09 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000006", Severity = ProcessMessageSeverity.Error,
                    Description = @"Declaration signature indicator must be true.",
                    Location = "/tns:LDGNN/tns:INT/tns:INTDeclaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000006"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN09", Value = GetValueOrEmpty(report.LDGNN09) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000006
    
            #region VR.ATO.LDGNN.000008
    
            /*  VR.ATO.LDGNN.000008
            TPAR non-lodgment advice can only be submitted for the 2013 financial year onwards.
    
            Legacy Rule Format:
            (^LDGNN06 = 'TPAR') AND (Year(^LDGNN08) < 2013)

            Technical Business Rule Format:
            (^LDGNN06 = 'TPAR') AND (Year(^LDGNN08) < 2013)
    
            Data Elements:
    
            ^LDGNN08 = LDGNN:RP:LodgmentNotNecessary:Period.End.Date
    
            ^LDGNN06 = LDGNN:RP:Tax.RoleType.Code
            */
            assertion = (report.LDGNN06 == @"TPAR" && Year(report.LDGNN08.GetValueOrDefault()) < 2013);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000008", Severity = ProcessMessageSeverity.Error,
                    Description = @"TPAR non-lodgment advice earlier than 2013 financial year.",
                    LongDescription = @"Taxable Payments Annual Report (TPAR) non-lodgment advices can only be submitted for the 2013 financial year onwards.",
                    Location = "/tns:LDGNN/tns:RP/tns:LodgmentNotNecessary/tns:PeriodEndD",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000008"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN06", Value = report.LDGNN06 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN08", Value = GetValueOrEmptyDate(report.LDGNN08) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000008
    
            #region VR.ATO.LDGNN.000009
    
            /*  VR.ATO.LDGNN.000009
            A Further returns not necessary reason must be provided for a TPAR FRNN non-lodgment advice.
    
            Legacy Rule Format:
            (^LDGNN06 = 'TPAR') AND (^LDGNN05 = 'Further Returns Not Necessary' AND  ^LDGNN12 = NULL)

            Technical Business Rule Format:
            (^LDGNN06 = 'TPAR') AND (^LDGNN05 = 'Further Returns Not Necessary' AND  ^LDGNN12 = NULL)
    
            Data Elements:
    
            ^LDGNN05 = LDGNN:RP:LodgmentNotNecessary:Lodgment.ReturnsNotNecessary.Code
    
            ^LDGNN06 = LDGNN:RP:Tax.RoleType.Code
    
            ^LDGNN12 = LDGNN:RP:Lodgment.FurtherReturnsNotNecessaryReason.Code
            */
            assertion = (report.LDGNN06 == @"TPAR" && (report.LDGNN05 == @"Further Returns Not Necessary" && report.LDGNN12 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000009", Severity = ProcessMessageSeverity.Error,
                    Description = @"Further returns not necessary reason not provided for TPAR FRNN.",
                    LongDescription = @"A Further return not necessary (FRNN) reason must be supplied when an FRNN non-lodgment advice is submitted for the Taxable Payments Annual Reporter (TPAR) role.",
                    Location = "/tns:LDGNN/tns:RP/tns:LodgmentNotNecessary/tns:ReturnsNotNecessaryC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000009"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN06", Value = report.LDGNN06 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN05", Value = report.LDGNN05 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN12", Value = GetValueOrEmpty(report.LDGNN12) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000009
    
            #region VR.ATO.LDGNN.000010
    
            /*  VR.ATO.LDGNN.000010
            If Role type equals 'ITI' then a Registered  Agent Number must be provided.
    
            Legacy Rule Format:
            ((^LDGNN06 = 'ITI') AND (^LDGNN02 = NULL))

            Technical Business Rule Format:
            ((^LDGNN06 = 'ITI') AND (^LDGNN02 = NULL))
    
            Data Elements:
    
            ^LDGNN06 = LDGNN:RP:Tax.RoleType.Code
    
            ^LDGNN02 = LDGNN:INT:Identifiers.TaxAgentNumber.Identifier
            */
            assertion = (report.LDGNN06 == @"ITI" && report.LDGNN02 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000010", Severity = ProcessMessageSeverity.Error,
                    Description = @"Registered Agent Number not provided for ITI Role type.",
                    LongDescription = @"A Registered agent number must be provided when a non-lodgment advice (NLA) is submitted for the Income Tax - Individual (ITI) role.",
                    Location = "/tns:LDGNN/tns:RP/tns:TaxRoleTypeC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000010"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN06", Value = report.LDGNN06 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN02", Value = GetValueOrEmpty(report.LDGNN02) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000010
    
            #region VR.ATO.LDGNN.000011
    
            /*  VR.ATO.LDGNN.000011
            Further return not necessary reason is not applicable to the ITI role type.
    
            Legacy Rule Format:
            ((^LDGNN06 = 'ITI') AND (^LDGNN12 <> NULL))

            Technical Business Rule Format:
            ((^LDGNN06 = 'ITI') AND (^LDGNN12 <> NULL))
    
            Data Elements:
    
            ^LDGNN06 = LDGNN:RP:Tax.RoleType.Code
    
            ^LDGNN12 = LDGNN:RP:Lodgment.FurtherReturnsNotNecessaryReason.Code
            */
            assertion = (report.LDGNN06 == @"ITI" && report.LDGNN12 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000011", Severity = ProcessMessageSeverity.Error,
                    Description = @"Further returns not necessary reason provided for ITI Role type.",
                    LongDescription = @"A Further returns not necessary reason is not applicable to the Income Tax - Individual (ITI) role, and must not be supplied.",
                    Location = "/tns:LDGNN/tns:RP/tns:TaxRoleTypeC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000011"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN06", Value = report.LDGNN06 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN12", Value = GetValueOrEmpty(report.LDGNN12) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000011
    
            #region VR.ATO.LDGNN.000012
    
            /*  VR.ATO.LDGNN.000012
            Further return not necessary reason is not applicable to the TPAR RNN non-lodgment advices.
    
            Legacy Rule Format:
            (^LDGNN06 = 'TPAR') AND (^LDGNN05 = 'Return Not Necessary' AND  ^LDGNN12 <> NULL)

            Technical Business Rule Format:
            (^LDGNN06 = 'TPAR') AND (^LDGNN05 = 'Return Not Necessary' AND  ^LDGNN12 <> NULL)
    
            Data Elements:
    
            ^LDGNN05 = LDGNN:RP:LodgmentNotNecessary:Lodgment.ReturnsNotNecessary.Code
    
            ^LDGNN06 = LDGNN:RP:Tax.RoleType.Code
    
            ^LDGNN12 = LDGNN:RP:Lodgment.FurtherReturnsNotNecessaryReason.Code
            */
            assertion = (report.LDGNN06 == @"TPAR" && (report.LDGNN05 == @"Return Not Necessary" && report.LDGNN12 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000012", Severity = ProcessMessageSeverity.Error,
                    Description = @"Further returns not necessary reason provided for TPAR RNN.",
                    LongDescription = @"A Further returns not necessary reason must not be supplied with a Return not necessary (RNN) advice on the Taxable Payments Annual Reporter (TPAR) role. ",
                    Location = "/tns:LDGNN/tns:RP/tns:LodgmentNotNecessary/tns:ReturnsNotNecessaryC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000012"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN06", Value = report.LDGNN06 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN05", Value = report.LDGNN05 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN12", Value = GetValueOrEmpty(report.LDGNN12) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000012
    
            #region VR.ATO.LDGNN.000013
    
            /*  VR.ATO.LDGNN.000013
            Period end date cannot precede period start date.
    
            Legacy Rule Format:
            (^LDGNN08 < ^LDGNN07)

            Technical Business Rule Format:
            ^LDGNN08 < ^LDGNN07
    
            Data Elements:
    
            ^LDGNN08 = LDGNN:RP:LodgmentNotNecessary:Period.End.Date
    
            ^LDGNN07 = LDGNN:RP:LodgmentNotNecessary:Period.Start.Date
            */
            assertion = (report.LDGNN08.GetValueOrDefault() < report.LDGNN07.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000013", Severity = ProcessMessageSeverity.Error,
                    Description = @"Period end date precedes Period start date.",
                    LongDescription = @"Period end date must be later than the Period start date.",
                    Location = "/tns:LDGNN/tns:RP/tns:LodgmentNotNecessary/tns:PeriodEndD",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000013"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN08", Value = GetValueOrEmptyDate(report.LDGNN08) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN07", Value = GetValueOrEmptyDate(report.LDGNN07) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000013
    
            #region VR.ATO.LDGNN.000015
    
            /*  VR.ATO.LDGNN.000015
            If provided, Reporting Party Signature Indicator must be 'TRUE'
    
            Legacy Rule Format:
            (^LDGNN304 <> NULL) AND (^LDGNN13 <> TRUE)

            Technical Business Rule Format:
            (^LDGNN304 <> NULL) AND (^LDGNN13 <> TRUE)
    
            Data Elements:
    
            ^LDGNN13 = LDGNN:RP:RPDeclaration:Declaration.StatementAccepted.Indicator
    
            ^LDGNN304 = LDGNN:RP:RPDeclaration
            */
            assertion = (report.RP_RPDeclarationCollectionExists != false && report.LDGNN13 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000015", Severity = ProcessMessageSeverity.Error,
                    Description = @"Declaration signature indicator must be true.",
                    Location = "/tns:LDGNN/tns:RP/tns:RPDeclaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000015"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "LDGNN13", Value = GetValueOrEmpty(report.LDGNN13) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000015
    
            #region VR.ATO.LDGNN.000016
    
            /*  VR.ATO.LDGNN.000016
            (The declaration must be provided by the sender.) If the sender is the Reporting Party then the declaration must be provided by Reporting Party
    
            Legacy Rule Format:
            (^LDGNN300 = NULL) AND (^LDGNN304 = NULL)

            Technical Business Rule Format:
            (^LDGNN300 = NULL) AND (^LDGNN304 = NULL)
    
            Data Elements:
    
            ^LDGNN300 = LDGNN:INT
    
            ^LDGNN304 = LDGNN:RP:RPDeclaration
            */
            assertion = (report.IntCollectionExists == false && report.RP_RPDeclarationCollectionExists == false);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.LDGNN.000016", Severity = ProcessMessageSeverity.Error,
                    Description = @"The sender's Declaration is not provided.",
                    LongDescription = @"The Declaration must be provided by the Reporting Party.",
                    Location = "/tns:LDGNN/tns:RP/tns:RPDeclaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.LDGNN.000016"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.LDGNN.000016

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }

            return response;
        }


    }
} 
